# include/config.Makefile.  Generated from config.Makefile.in by configure. -*- makefile -*-
ifneq ($(CONFIG_MAKEFILE),)
$(error config.Makefile already loaded)
endif
CONFIG_MAKEFILE = loaded
.PHONY: all check initialize clean distclean install always reconfigure big-check
all:

SHELL = /bin/sh

.DELETE_ON_ERROR:

# here we set the variables that "make" uses
CC = gcc
CXX = g++
FC = gfortran
CFLAGS = -g -O2
CPPFLAGS = -I/usr/include/libxml2  -DNDEBUG
CXXFLAGS = -g -O2
FCFLAGS = -g -O2
LDFLAGS = 

# Macaulay 2 file system layout definitions, dependent on $(prefix) and PackageName.
#  see http://www.pathname.com/fhs/
#      http://fink.sourceforge.net/doc/packaging/fslayout.php
#      http://cr.yp.to/unix.html, the section on "Filesystem layout"

### Here we set the make-variables that configure uses as make-variables inside configure-variables.
# The user may override only "prefix" and "exec_prefix"
prefix = /usr/local
exec_prefix = ${prefix}
datarootdir = ${prefix}/share
PACKAGE_TARNAME = Macaulay2
docdir = ${prefix}/share/doc/Macaulay2

# We assume relative positions of files within the tree are known to the configure script.
# Thus the user should not override these on the "make" command line, but may
# override them on the "configure" command line instead:
pre_prefix = /home/tom/software/M2/M2/StagingArea/common
pre_exec_prefix = /home/tom/software/M2/M2/StagingArea/x86_64-Linux-a
# we want to ignore the --datarootdir setting, whatever that means, so here we we mention it: ${prefix}/share
abs_top_srcdir = /home/tom/software/M2/M2


INSTALL = /usr/bin/install -c

# we can't use -isystem instead of -I for our library include files, because then they might be supplanted
# by older include files in a directory specified by the user with CPPFLAGS=-I/foo/bar, causing
# version skew (gcc preprocessor searches -I directories first, then -isystem directories)

BUILTLIBPATH = /home/tom/software/M2/M2/libraries/final

# this will be a symbolic link installed by libraries/gtest/Makefile
GTEST_DIR = /home/tom/software/M2/M2/libraries/final/gtest

CPPFLAGS := \
	 -I/home/tom/software/M2/M2/include \
	 -I/home/tom/software/M2/M2/include \
	 -I$(BUILTLIBPATH)/include \
	 $(CPPFLAGS)

ifeq "no" "yes"
CPPFLAGS := -I$(BUILTLIBPATH)/include/mpack $(CPPFLAGS)
endif

vpath %.h $(BUILTLIBPATH)/include
LDFLAGS := -L$(BUILTLIBPATH)/lib $(LDFLAGS)
vpath %.a $(BUILTLIBPATH)/lib
vpath %.o $(BUILTLIBPATH)/lib
vpath %.so $(BUILTLIBPATH)/lib
LD_LIBRARY_PATH := $(BUILTLIBPATH)/lib:$(LD_LIBRARY_PATH)
export LD_LIBRARY_PATH
export PATH := /home/tom/software/M2/M2/bin:${PATH}
AR = ar
ifeq (,$(findstring --no-print-directory,$(word 1,$(MAKEFLAGS))))
MAKEFLAGS += -w
endif
ifeq "Linux x86_64" "Linux alpha"
AS = gcc -c -x assembler-with-cpp
endif
M2_CPPFLAGS +=  -DNDEBUG
ifeq "yes" "yes"
# if it's gcc, we can get stricter warning and error messages
ifneq ($(RELAX),yes)
# but sometimes that's bad, e.g., during configure scripts with loosely written test programs
# -Winline gives too many warning messages

M2_BOTH = -pipe -Wall -Wno-shadow -Wcast-qual

# use no GNU extensions
# CXXFLAGS += -std=c++98
# using -std=c99 is a bad idea, because in ubuntu, this standard causes __USE_POSIX to be undefined, 
#   hence sigjmp_buf to be undefined, which is needed by gc
# CFLAGS += -std=c99

ifeq "no" "yes"
X = -diag-disable 981,869,383,2259,444
CFLAGS += $X
CXXFLAGS += $X
ifeq "no" "yes"
CFLAGS += -debug
CXXFLAGS += -debug
LDFLAGS += -debug
endif
else
M2_BOTH += -Wno-parentheses
M2_BOTH += -Wno-sign-compare 
endif

M2_BOTH += -fno-stack-protector

ifeq "yes" "yes"
# gcc 3.3.2 doesn't accept this:
# M2_BOTH += -Werror=uninitialized
M2_BOTH += -Wuninitialized
endif

M2_CFLAGS   += $(M2_BOTH) -Wwrite-strings
M2_CXXFLAGS += $(M2_BOTH) -Wconversion

M2_CFLAGS +=  -Wstrict-aliasing -Wfatal-errors

# M2_CFLAGS   += -Werror=implicit-function-declaration -Werror=write-strings $(M2_BOTH)
ifeq "no" "no"
M2_CFLAGS   += -Wimplicit-function-declaration
endif


# -Werror-implicit-function-declaration is important, because if we include the wrong include file and a function that
# returns a 64-bit pointer is not declared as such, then only 32 bits of the return value will be used.
endif
endif
STRIPCMD = strip
ifeq "$(STRIP)" "yes"
ifneq "Linux" "Darwin"
LDFLAGS  += -s
endif
endif
MKDIR_P = /usr/bin/install -c -d
always:

# pari tends to display plots during its tests, and we don't want that:
export DISPLAY=

# Safe C language:
SCCFLAGS =
ifeq "no" "no"
SCCFLAGS += -O
endif
SCC1 = /home/tom/software/M2/M2/Macaulay2/c/scc1

# scc1 output files

ifeq "$(NORULES)" ""

.SUFFIXES : .sig.tmp .sig .dep .d .dd -exports.h.tmp -exports.h -tmp.c -tmp.cc

%.sig: ;	test -e $*.sig && cmp -s $*.sig.tmp $*.sig || cp $*.sig.tmp $*.sig
%-exports.h: ;	test -e $*-exports.h && cmp -s $*-exports.h.tmp $*-exports.h || cp $*-exports.h.tmp $*-exports.h

%.sig.tmp %.dep: %.d
	$(SCC1) -dep $(SCCFLAGS) $<
	mv $*.dep.tmp $*.dep
	test -e $*.sig && cmp -s $*.sig.tmp $*.sig || cp $*.sig.tmp $*.sig
%.sig.tmp %.dep: %.dd
	$(SCC1) -dep $(SCCFLAGS) $<
	mv $*.dep.tmp $*.dep
	test -e $*.sig && cmp -s $*.sig.tmp $*.sig || cp $*.sig.tmp $*.sig
%-tmp.c  %-exports.h.tmp: %.d
	$(SCC1) $(SCCFLAGS) $<
	test -e $*-exports.h && cmp -s $*-exports.h.tmp $*-exports.h || cp $*-exports.h.tmp $*-exports.h
%-tmp.cc %-exports.h.tmp: %.dd
	$(SCC1) $(SCCFLAGS) $<
	test -e $*-exports.h && cmp -s $*-exports.h.tmp $*-exports.h || cp $*-exports.h.tmp $*-exports.h
%.o: %-tmp.c  %-exports.h;		$(COMPILE.c)  $(DCFLAGS) $< $(OUTPUT_OPTION)
%.o: %-tmp.cc %-exports.h;		$(COMPILE.cc) $(DCFLAGS) $< $(OUTPUT_OPTION)

# various compiler output files
.SUFFIXES : .ss .ii .s
%.ss: %.s; demangle <$< >$@
%.ii: %.cpp; $(PRE.cc)        $< $(OUTPUT_OPTION)
%.s : %.cpp; $(COMPILE.cc) -S $< $(OUTPUT_OPTION)
%.ii: %.cc; $(PRE.cc)        $< $(OUTPUT_OPTION)
%.s : %.cc; $(COMPILE.cc) -S $< $(OUTPUT_OPTION)
%.ii: %.c; $(PRE.c)        $< $(OUTPUT_OPTION)
%.s : %.c; $(COMPILE.c) -S $< $(OUTPUT_OPTION)

endif

# libgc
export GC_LARGE_ALLOC_WARN_INTERVAL=1

# Local Variables:
# compile-command: "make -C $M2BUILDDIR include/config.Makefile DEPENDS=no "
# End:
